DEFINT A-Z

TYPE REGS386
  AX    AS INTEGER
  BX    AS INTEGER
  CX    AS INTEGER
  DX    AS INTEGER
  SI    AS INTEGER
  DI    AS INTEGER
  DS    AS INTEGER
  ES    AS INTEGER
  flags AS INTEGER
  BP    AS INTEGER
' standard ^
  FS    AS INTEGER
  GS    AS INTEGER
  EAX   AS LONG
  EBX   AS LONG
  ECX   AS LONG
  EDX   AS LONG
  ESI   AS LONG
  EDI   AS LONG
  EBP   AS LONG
' extended ^
END TYPE

DECLARE SUB COLORPRINTS (x%, y%, s$, f%, b%)
DECLARE FUNCTION RCHANGE% (r AS REGS386)
DECLARE FUNCTION SIGN% (n&)
DECLARE SUB FIXREGS (r AS REGS386)
DECLARE SUB CLEARREGS (r AS REGS386)
DECLARE FUNCTION PAD$ (s$, leng%, char%, ltrtcntr%)
DECLARE FUNCTION TRUNC$ (s$, leng%)
DECLARE SUB PRINTREGS (x, y, r AS REGS386, f, b)
DECLARE SUB INT386 (in AS INTEGER, r1 AS REGS386, r2 AS REGS386)
DECLARE SUB MAIN ()

MAIN
'PAD$(MKI$(n), 2, 0, 1) '

1
  DATA "AX   ","BX   "
  DATA "CX   ","DX   "
  DATA "SI   ","DI   "
  DATA "DS   ","ES   "
  DATA "FLAGS","BP   "
  DATA "FS   "
  DATA "GS   ","EAX  "
  DATA "EBX  ","ECX  "
  DATA "EDX  ","ESI  "
  DATA "EDI  ","EBP  "

2
  
  DATA ""
  DATA "                       "
  DATA " 80386+ Interrupt Demo "
  DATA "                       "
  DATA ""
  
  DATA "۲ INT 33h/AX = 0003h - Mouse Coordinates and Buttons ۲"
  DATA "۲ By: John Anderson ۲"
  DATA "۲ Press Esc to Exit ۲"

SUB CLEARREGS (r AS REGS386)
  r.AX = 0
  r.BX = 0
  r.CX = 0
  r.DX = 0
  r.SI = 0
  r.DI = 0
  r.DS = 0
  r.ES = 0
  r.flags = 0
  r.BP = 0
  r.FS = 0
  r.GS = 0
  r.EAX = 0
  r.EBX = 0
  r.ECX = 0
  r.EDX = 0
  r.ESI = 0
  r.EDI = 0
  r.EBP = 0
END SUB

SUB COLORPRINTS (x, y, s$, f, b)
  COLOR f, b
  LOCATE y, x
  PRINT s$
  COLOR 7, 0
END SUB

SUB FIXREGS (r AS REGS386)
  IF (r.AX = 0) AND (r.EAX <> 0) THEN r.AX = SIGN(r.EAX AND &HFFFF)
  IF (r.BX = 0) AND (r.EBX <> 0) THEN r.BX = SIGN(r.EBX AND &HFFFF)
  IF (r.CX = 0) AND (r.ECX <> 0) THEN r.CX = SIGN(r.ECX AND &HFFFF)
  IF (r.DX = 0) AND (r.EDX <> 0) THEN r.DX = SIGN(r.EDX AND &HFFFF)
  IF (r.SI = 0) AND (r.ESI <> 0) THEN r.SI = SIGN(r.ESI AND &HFFFF)
  IF (r.DI = 0) AND (r.EDI <> 0) THEN r.DI = SIGN(r.EDI AND &HFFFF)
  IF (r.BP = 0) AND (r.EBP <> 0) THEN r.BP = SIGN(r.EBP AND &HFFFF)
END SUB

SUB INT386 (in AS INTEGER, r1 AS REGS386, r2 AS REGS386) STATIC

FIXREGS r1
IF ((i386$ = "") OR (in <> oin)) THEN
'*****************************************************************************
'<insert code here>
i386$ = ""
'0000    PUSH BP                                            55
  i386$ = i386$ + CHR$(&H55)
'0001    MOV BP, SP                                         8BEC
  i386$ = i386$ + CHR$(&H8B) + CHR$(&HEC)
'0003    PUSH DS                                            1E
  i386$ = i386$ + CHR$(&H1E)
'0004    ADD BP, 06                                         81C50600
  i386$ = i386$ + CHR$(&H81) + CHR$(&HC5) + CHR$(&H6) + CHR$(&H0)
'#######Change Segment############
'0008    MOV SI, 0000                                       BE0000
  i386$ = i386$ + CHR$(&HBE) + MID$(PAD$(MKI$(VARPTR(r1.AX)), 2, 0, 1), 1, 2)
'#################################
'000B    MOV CX, 0C                                         B90C00
  i386$ = i386$ + CHR$(&HB9) + CHR$(&HC) + CHR$(&H0)
'000E    MOV DX, 02                                         BA0200
  i386$ = i386$ + CHR$(&HBA) + CHR$(&H2) + CHR$(&H0)
'next2push:
'0011    PUSH [SI]                                          FF35
  i386$ = i386$ + CHR$(&HFF) + CHR$(&H34)
'0013    ADD SI, DX                                         03FA
  i386$ = i386$ + CHR$(&H3) + CHR$(&HF2)
'0015    LOOP next2push                                     E2FA
  i386$ = i386$ + CHR$(&HE2) + CHR$(&HFA)
'#################################
'0017    MOV CX, 07                                         B90700
  i386$ = i386$ + CHR$(&HB9) + CHR$(&H7) + CHR$(&H0)
'001A    MOV DX, 04                                         BA0400
  i386$ = i386$ + CHR$(&HBA) + CHR$(&H4) + CHR$(&H0)
'next4push:
'001D    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'001E    PUSH [SI]                                          FF35
  i386$ = i386$ + CHR$(&HFF) + CHR$(&H34)
'0020    ADD SI, DX                                         03FA
  i386$ = i386$ + CHR$(&H3) + CHR$(&HF2)
'0022    LOOP next4push                                     E2F9
  i386$ = i386$ + CHR$(&HE2) + CHR$(&HF9)
'#################################
'0024    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0025    POP BP                                             5D
  i386$ = i386$ + CHR$(&H5D)
'0026    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0027    POP DI                                             5F
  i386$ = i386$ + CHR$(&H5F)
'0028    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0029    POP SI                                             5E
  i386$ = i386$ + CHR$(&H5E)
'002A    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'002B    POP DX                                             5A
  i386$ = i386$ + CHR$(&H5A)
'002C    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'002D    POP CX                                             59
  i386$ = i386$ + CHR$(&H59)
'002E    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'002F    POP BX                                             5B
  i386$ = i386$ + CHR$(&H5B)
'0030    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0031    POP AX                                             58
  i386$ = i386$ + CHR$(&H58)
'#################################
'0049    NOP                                                0F
  i386$ = i386$ + CHR$(&HF)
'004A    POP GS                                            A9
  i386$ = i386$ + CHR$(&HA9)
'004B    NOP                                                0F
  i386$ = i386$ + CHR$(&HF)
'004C    POP FS                                            A1
  i386$ = i386$ + CHR$(&HA1)
'#################################
'0036    POP BP                                             5D
  i386$ = i386$ + CHR$(&H5D)
'0037    POPF                                               9D
  i386$ = i386$ + CHR$(&H9D)
'0038    POP ES                                             07
  i386$ = i386$ + CHR$(&H7)
'0039    POP DS                                             1F
  i386$ = i386$ + CHR$(&H1F)
'003A    POP DI                                             5F
  i386$ = i386$ + CHR$(&H5F)
'003B    POP SI                                             5E
  i386$ = i386$ + CHR$(&H5E)
'003C    POP DX                                             5A
  i386$ = i386$ + CHR$(&H5A)
'003D    POP CX                                             59
  i386$ = i386$ + CHR$(&H59)
'003E    POP BX                                             5B
  i386$ = i386$ + CHR$(&H5B)
'003F    POP AX                                             58
  i386$ = i386$ + CHR$(&H58)
'##################################################################
'0039    INT --                                             CD--
  i386$ = i386$ + CHR$(&HCD) + CHR$(in)
'##################################################################
'0042    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0043    PUSH BP                                            55
  i386$ = i386$ + CHR$(&H55)
'0044    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0045    PUSH DI                                            57
  i386$ = i386$ + CHR$(&H57)
'0046    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0047    PUSH SI                                            56
  i386$ = i386$ + CHR$(&H56)
'0048    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0049    PUSH DX                                            52
  i386$ = i386$ + CHR$(&H52)
'004A    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'004B    PUSH CX                                            51
  i386$ = i386$ + CHR$(&H51)
'004C    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'004D    PUSH BX                                            53
  i386$ = i386$ + CHR$(&H53)
'004E    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'004F    PUSH AX                                            50
  i386$ = i386$ + CHR$(&H50)
'#################################
'0049    NOP                                                0F
  i386$ = i386$ + CHR$(&HF)
'004A    PUSH GS                                            A1
  i386$ = i386$ + CHR$(&HA8)
'004B    NOP                                                0F
  i386$ = i386$ + CHR$(&HF)
'004C    PUSH FS                                            A0
  i386$ = i386$ + CHR$(&HA0)
'#################################
'0054    PUSH BP                                            55
  i386$ = i386$ + CHR$(&H55)
'0055    PUSHF                                              9C
  i386$ = i386$ + CHR$(&H9C)
'0056    PUSH ES                                            06
  i386$ = i386$ + CHR$(&H6)
'0057    PUSH DS                                            1E
  i386$ = i386$ + CHR$(&H1E)
'0058    PUSH DI                                            57
  i386$ = i386$ + CHR$(&H57)
'0059    PUSH SI                                            56
  i386$ = i386$ + CHR$(&H56)
'005A    PUSH DX                                            52
  i386$ = i386$ + CHR$(&H52)
'005B    PUSH CX                                            51
  i386$ = i386$ + CHR$(&H51)
'005C    PUSH BX                                            53
  i386$ = i386$ + CHR$(&H53)
'005D    PUSH AX                                            50
  i386$ = i386$ + CHR$(&H50)
'005E    MOV AX, SS                                         8CD0
  i386$ = i386$ + CHR$(&H8C) + CHR$(&HD0)
'0060    MOV DS, AX                                         8ED8
  i386$ = i386$ + CHR$(&H8E) + CHR$(&HD8)
'0062    MOV DI, 0000                                       BF0000
  i386$ = i386$ + CHR$(&HBF) + MID$(PAD$(MKI$(VARPTR(r2.AX)), 2, 0, 1), 1, 2)
'#################################
'0065    MOV CX, 0C                                         B90C00
  i386$ = i386$ + CHR$(&HB9) + CHR$(&HC) + CHR$(&H0)
'0068    MOV DX, 02                                         BA0200
  i386$ = i386$ + CHR$(&HBA) + CHR$(&H2) + CHR$(&H0)
'next2pop:
'006B    POP [DI]                                           8F05
  i386$ = i386$ + CHR$(&H8F) + CHR$(&H5)
'006D    ADD DI, DX                                         03FA
  i386$ = i386$ + CHR$(&H3) + CHR$(&HFA)
'006F    LOOP next2pop                                      E2FA
  i386$ = i386$ + CHR$(&HE2) + CHR$(&HFA)
'#################################
'0071    MOV CX, 07                                         B90700
  i386$ = i386$ + CHR$(&HB9) + CHR$(&H7) + CHR$(&H0)
'0074    MOV DX, 04                                         BA0400
  i386$ = i386$ + CHR$(&HBA) + CHR$(&H4) + CHR$(&H0)
'next4pop:
'0077    NOP                                                66
  i386$ = i386$ + CHR$(&H66)
'0078    POP [DI]                                           8F05
  i386$ = i386$ + CHR$(&H8F) + CHR$(&H5)
'007A    ADD DI, DX                                         03FA
  i386$ = i386$ + CHR$(&H3) + CHR$(&HFA)
'007C    LOOP next4pop                                      E2F9
  i386$ = i386$ + CHR$(&HE2) + CHR$(&HF9)
'#################################
'007E    POP DS                                             1F
  i386$ = i386$ + CHR$(&H1F)
'007F    POP BP                                             5D
  i386$ = i386$ + CHR$(&H5D)
'0080    RETF                                               CB
  i386$ = i386$ + CHR$(&HCB)
'---------------
'*****************************************************************************
END IF
DEF SEG = VARSEG(i386$)
offset% = SADD(i386$)
IF 0 THEN
  CLS
  PRINT VARSEG(i386$)
  PRINT SADD(i386$)
  FOR x = 0 TO LEN(i386$) - 1
    PRINT HEX$(PEEK(offset% + x)); " ";
  NEXT
  OPEN "D:\programs\qb\qb11cint\int386\debugr.com" FOR BINARY ACCESS READ WRITE AS #1
  SEEK #1, 1
  PUT #1, , i386$
  CLOSE #1
ELSEIF 1 THEN
  DIM var%(1 TO 2)
  CALL ABSOLUTE(VARPTR(r1), VARPTR(r2), offset%)
END IF
DEF SEG
oin = in
END SUB

SUB MAIN
  DIM start
  DIM ocx, odx, rc
  DIM r AS REGS386
  DIM i$, x
  start = -1
  SCREEN 0
  WIDTH 80, 50
  COLOR , 1
  CLS
  CLEARREGS r
  r.AX = 1
  INT386 &H33, r, r
  RESTORE 2
  FOR x = 1 TO 5
    READ s$
    COLORPRINTS ((80 - LEN(s$)) \ 2), x, s$, &O17, 1
  NEXT
  READ s$
  COLORPRINTS ((80 - LEN(s$)) \ 2), 8, s$, &O14, 1
  READ s$
  COLORPRINTS ((80 - LEN(s$)) \ 2), 34, s$, &O13, 1
  READ s$
  COLORPRINTS ((80 - LEN(s$)) \ 2), 36, s$, &O17, 1
  DO
    CLEARREGS r
    r.EAX = 3
    r.BP = 0
    r.EBP = &H20002
    IF start THEN
      PRINTREGS 12, 10, r, &O12, 1
    END IF
    INT386 &H33, r, r
    rc = RCHANGE(r)
    IF ((rc) OR (start)) THEN
      PRINTREGS 38, 10, r, &O16, 1
      GOSUB RenewCursor
      start = 0
    END IF
    ocx = r.CX: odx = r.DX
    i$ = INKEY$
    IF i$ = CHR$(27) THEN EXIT DO
  LOOP
  CLEARREGS r
  r.AX = 2
  INT386 &H33, r, r
EXIT SUB
RenewCursor:
  CLEARREGS r
  r.AX = 2
  INT386 &H33, r, r
  CLEARREGS r
  r.AX = 1
  INT386 &H33, r, r
  CLEARREGS r
  r.AX = 3
  INT386 &H33, r, r
RETURN
END SUB

FUNCTION PAD$ (s$, leng, char, ltrtcntr)
  DIM P$, leng2, diff
  P$ = LTRIM$(RTRIM$(s$))
  leng2 = LEN(P$)
  IF (leng > leng2) THEN
    diff = leng - leng2
    SELECT CASE (ltrtcntr)
      CASE 1: P$ = s$ + STRING$(diff, char)
      CASE 2: P$ = STRING$((diff \ 2) + (diff MOD 2), char) + s$ + STRING$((diff \ 2), char)
      CASE ELSE: P$ = STRING$(diff, char) + s$
    END SELECT
  ELSEIF (leng = leng2) THEN
    P$ = s$
  ELSE
    P$ = TRUNC$(s$, leng)
  END IF
  PAD$ = P$
END FUNCTION

SUB PRINTREGS (x, y, r AS REGS386, f, b)
  COLOR f AND &HF, b AND &H7
  RESTORE 1
  READ varname$: LOCATE y, x
    PRINT varname$ + PAD$(STR$(r.AX), 10, 32, 0) + " " + PAD$(HEX$(r.AX), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.BX), 10, 32, 0) + " " + PAD$(HEX$(r.BX), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.CX), 10, 32, 0) + " " + PAD$(HEX$(r.CX), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.DX), 10, 32, 0) + " " + PAD$(HEX$(r.DX), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.SI), 10, 32, 0) + " " + PAD$(HEX$(r.SI), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.DI), 10, 32, 0) + " " + PAD$(HEX$(r.DI), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.DS), 10, 32, 0) + " " + PAD$(HEX$(r.DS), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.ES), 10, 32, 0) + " " + PAD$(HEX$(r.ES), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.flags), 10, 32, 0) + " " + PAD$(HEX$(r.flags), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.BP), 10, 32, 0) + " " + PAD$(HEX$(r.BP), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.FS), 10, 32, 0) + " " + PAD$(HEX$(r.FS), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.GS), 10, 32, 0) + " " + PAD$(HEX$(r.GS), 4, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.EAX&), 10, 32, 0) + " " + PAD$(HEX$(r.EAX&), 8, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.EBX&), 10, 32, 0) + " " + PAD$(HEX$(r.EBX&), 8, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.ECX&), 10, 32, 0) + " " + PAD$(HEX$(r.ECX&), 8, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.EDX&), 10, 32, 0) + " " + PAD$(HEX$(r.EDX&), 8, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.ESI&), 10, 32, 0) + " " + PAD$(HEX$(r.ESI&), 8, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.EDI&), 10, 32, 0) + " " + PAD$(HEX$(r.EDI&), 8, &H30, 0)
  READ varname$: LOCATE CSRLIN, x
    PRINT varname$ + PAD$(STR$(r.EBP&), 10, 32, 0) + " " + PAD$(HEX$(r.EBP&), 8, &H30, 0)
  COLOR 7, 0
END SUB

FUNCTION RCHANGE (r AS REGS386) STATIC
  DIM init
  DIM tst, rc
  rc = 0
  IF NOT init THEN
    DIM rr AS REGS386
    rr = r
    init = -1
  END IF
  tst = (r.AX <> rr.AX)
  tst = tst OR (r.BX <> rr.BX)
  tst = tst OR (r.CX <> rr.CX)
  tst = tst OR (r.DX <> rr.DX)
  tst = tst OR (r.SI <> rr.SI)
  tst = tst OR (r.DI <> rr.DI)
  tst = tst OR (r.DS <> rr.DS)
  tst = tst OR (r.ES <> rr.ES)
  tst = tst OR (r.flags <> rr.flags)
  tst = tst OR (r.BP <> rr.BP)
  tst = tst OR (r.FS <> rr.FS)
  tst = tst OR (r.GS <> rr.GS)
  tst = tst OR (r.EAX <> rr.EAX)
  tst = tst OR (r.EBX <> rr.EBX)
  tst = tst OR (r.ECX <> rr.ECX)
  tst = tst OR (r.EDX <> rr.EDX)
  tst = tst OR (r.ESI <> rr.ESI)
  tst = tst OR (r.EDI <> rr.EDI)
  tst = tst OR (r.EBP <> rr.EBP)
  rr = r
  RCHANGE = tst
END FUNCTION

FUNCTION SIGN (n&) STATIC
  DIM s
  POKE VARPTR(s), PEEK(VARPTR(n&))
  POKE VARPTR(s) + 1, PEEK(VARPTR(n&) + 1)
  SIGN = s
END FUNCTION

FUNCTION TRUNC$ (s$, leng)
  DIM leng2, t$
  leng2 = LEN(t$)
  IF (leng2 < leng) THEN
    t$ = MID$(s$, 1, leng2)
  ELSE
    t$ = s$
  END IF
  TRUNC$ = t$
END FUNCTION

